"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.run = void 0;
const core_1 = require("@serverless-cd/core");
const deploy_1 = __importDefault(require("./deploy"));
const deploy_2 = __importDefault(require("./deploy"));
const getPluginInputs = (inputs, context, logger) => __awaiter(void 0, void 0, void 0, function* () {
    logger.debug(`context: ${JSON.stringify(context)}`);
    logger.debug(`original inputs: ${JSON.stringify(inputs)}`);
    const newInputs = core_1.lodash.assign((0, core_1.getInputs)(inputs, context), {
        deployFile: core_1.lodash.get(context, 'inputs.context.data.deployFile'),
        envName: core_1.lodash.get(context, 'inputs.context.data.envDeploymentName')
    });
    logger.debug(`merged inputs: ${JSON.stringify(newInputs)}`);
    return {
        deployFile: core_1.lodash.get(newInputs, 'deployFile'),
        deployArgs: core_1.lodash.get(newInputs, 'deployArgs'),
        envName: core_1.lodash.get(newInputs, 'envName'),
        resource: core_1.lodash.get(newInputs, 'resource'),
        debugMode: core_1.lodash.get(newInputs, 'debugMode') || core_1.lodash.get(context, 'inputs.ctx.data.runnerConfig.debugMode'),
        workspace: core_1.lodash.get(context, 'cwd'),
    };
});
const run = (inputs, context, logger) => __awaiter(void 0, void 0, void 0, function* () {
    logger.info('start @serverless-cd/s-deploy run');
    const props = yield getPluginInputs(inputs, context, logger);
    const deploy = new deploy_2.default(props, logger);
    const res = yield deploy.run();
    logger.info('Run @serverless-cd/s-deploy end');
});
exports.run = run;
exports.default = deploy_1.default;
//# sourceMappingURL=index.js.map